﻿EnableExplicit

#CalaymClassNameMsg = "CalaymInterMsgClass101"
#CalaymClassTitleMsg = "Calaym"
#CalaymClassForm = "CalaymPlayerWindow"
#CalaymClassStaticWhiteDC = "CalaymUniWhiteBkControl"
#CalaymClassSplitterTH = "CalaymDirListSplitterVrt"
#CalaymClassSplitterLW = "CalaymDirListSplitterHrz"
#CalaymClassSplitterMoveTH = "CalaymDirListSplitterVrtMoving"
#CalaymClassSplitterMoveLW = "CalaymDirListSplitterHrzMoving"
#CalaymClassToolTip = "CalaymToolTip"


;0-5=defs
#xStaticIcons_Def0 = 0
#xStaticIcons_Def1 = 1
#xStaticIcons_Def2 = 2
#xStaticIcons_Def3 = 3
#xStaticIcons_Def4 = 4
#xStaticIcons_Def5 = 5
#xStaticIcons_Volume = 6
#xStaticIcons_RepMode = 7
#xStaticIcons_TimerInd = 8
;;;#xStaticIcons_MP3FormatIcon = 9
#xStaticIcons_Anim = 9
#xStaticIcons_LastBMP = 9
Global Dim xStaticIconsBMP.i(#xStaticIcons_LastBMP)
#xStaticIcons_Spectrum = 10
#xStaticIcons_DirList = 11
#xStaticIcons_CurSong = 12
#xStaticIcons_CurSongPos = 13
#xStaticIcons_Tags = 14
#xStaticIcons_ShowIR = 15
#xStaticIcons_Last = 15
#xStaticIcons_ToolTip = 16
#xStaticIcons_BAR = 17
Global Dim xStaticIconsHWnd.i(#xStaticIcons_BAR)
Global Dim xStaticIconsToolTip.s(#xStaticIcons_Tags, 1)
Global Dim xListHWnd.i(2)
Global MainFormIsSplitterMovingTH.i
Global MainFormIsSplitterMovingLW.i
Global CurShownToolTip.i
Global ToolTipInitTime.i
Global ToolTipDelay.i
#TTSplitter = Chr(13)
#TTSplitterTab = Chr(9)
#TTSplitter2 = #TTSplitter ;+ TTSplitter
Global hFontTTip.i
Global CurShownToolTip_SpHeight.i
Global CurShownToolTip_SpKeyPre.i
Global CurShownToolTip_SpKey.i
Global CurShownToolTip_TotalWidthX.i
#TTSpaceLeft = 5
;#TTSpaceLeftD = TTSpaceLeft * 2
#TTSpaceTop = 3
#TTSpaceTopD = #TTSpaceTop * 2
Global SysColor23.i
Global SysColor24.i
Global ScrollComboWidth.i
Global hThemeComboDropButtons.i
#FillSysColorBack = 5 + 1 ;$F& + 1
#FillSysColorFore = 13 + 1
#FillSysColorFace = 15 + 1 ;$F& + 1
#FillSysColorSunkenD = 16 + 1 ;$F& + 1
#FillSysColorSunkenW = 20 + 1 ;$F& + 1
Global FormatIconBackSunken.i
Global FormatIconBackSunkenD.i
Global FormatIconBackSunkenW.i
Global FormatIconFore.i
Global MP3FormatBitmap.i
Global DPIScaleX.f
Global DPIScaleY.f
Global xVolMTbWidth.i
Global xVolTotWidth.i

Procedure DrawWhiteDCDropButton(hWnd.i, IDUpOrDown.i, IsDown.i)
  Define.i xLong1
  Define.i xLong2
  Define.RECT xType1
  
  If GetClientRect_(hWnd, @xType1)
    xLong1 = GetDC_(hWnd)
    If xLong1
      xType1\left = xType1\Right - ScrollComboWidth ;3
      If hThemeComboDropButtons
        xLong2 = IDUpOrDown * 4 + 1 + IsDown * 2
        If IsThemeBackgroundPartiallyTransparent(hThemeComboDropButtons, 1, xLong2)
          DrawThemeParentBackground(hWnd, xLong1, @xType1)
          EndIf
        DrawThemeBackground(hThemeComboDropButtons, xLong1, 1, xLong2, @xType1, 0)
        Else
        DrawFrameControl_(xLong1, @xType1, 3, IsDown * $200 + IDUpOrDown) ;(ID & $1))
        EndIf
      ReleaseDC_(hWnd, xLong1)
      EndIf
    EndIf
  EndProcedure


Procedure CalcToolTip()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.s xChar1
  Define.POINT xType1
  Define.POINT xType2
  Define.RECT xType3
  Define.i xCount
  
  xChar1 = xStaticIconsToolTip(CurShownToolTip, 0) + #TTSplitter
  SelectObject_(xSharedDC, hFontTTip)
  Repeat
    xLong1 = FindString(xChar1, #TTSplitter)
    If xLong1 = 0
      Break
      EndIf
    If xCount = 1
      xType3\Bottom = xType3\Bottom + 5
      EndIf
    xCount = xCount + 1
    GetTextExtentPoint32_(xSharedDC, @xChar1, xLong1 - 1, @xType1)
    If xType1\x > xType3\Right
      xType3\Right = xType1\x
      EndIf
    xType3\Bottom = xType3\Bottom + CurShownToolTip_SpHeight
    xChar1 = Mid(xChar1, xLong1 + 1)
    ForEver
  xType3\Right = xType3\Right + #TTSpaceLeft
  
  CurShownToolTip_SpKey = 0
  If Not Len(xStaticIconsToolTip(CurShownToolTip, 1)) = 0
    ;If xCount < 2
      ;xType3\Bottom = xType3\Bottom + 5
      ;EndIf
    xType3\Bottom = xType3\Bottom + 4
    
    xChar1 = xStaticIconsToolTip(CurShownToolTip, 1) + #TTSplitter2
    If FindString(xChar1, #TAB$) = 0
      xChar1 = #TAB$ + xChar1
      EndIf
    Repeat
      xLong1 = FindString(xChar1, #TTSplitterTab)
      xLong2 = FindString(xChar1, #TTSplitter)
      If xLong1 = 0 Or xLong2 = 0 Or xLong1 > xLong2
        Break
        EndIf
      GetTextExtentPoint32_(xSharedDC, @xChar1, xLong1 - 1, @xType1)
      If xType1\x > CurShownToolTip_SpKey
        CurShownToolTip_SpKey = xType1\x
        EndIf
      xChar1 = Mid(xChar1, xLong1 + 1)
      GetTextExtentPoint32_(xSharedDC, @xChar1, xLong2 - xLong1 - 1, @xType1)
      If xType1\x > xLong3
        xLong3 = xType1\x
        EndIf
      xType3\Bottom = xType3\Bottom + CurShownToolTip_SpHeight
      xChar1 = Mid(xChar1, xLong2 - xLong1 + 1)
      ForEver
    CurShownToolTip_SpKey = CurShownToolTip_SpKeyPre + CurShownToolTip_SpKey ;+ #TTSpaceLeft
    xLong3 = xLong3 + CurShownToolTip_SpKey ;+CurShownToolTip_SpKeyPre
    If xLong3 > xType3\Right
      xType3\Right = xLong3
      EndIf
    EndIf
  
  xType3\Right = xType3\Right + #TTSpaceLeft
  CurShownToolTip_TotalWidthX = xType3\Right
  xType3\Bottom = xType3\Bottom + #TTSpaceTopD
  AdjustWindowRectEx_(@xType3, $8E800000, 0, $84)
  xType1\x = xType3\Right - xType3\left
  xType1\y = xType3\Bottom - xType3\Top
  WindowToCursorPos(xType1, xType2)
  SetWindowPos_(xStaticIconsHWnd(#xStaticIcons_ToolTip), 0, xType2\x, xType2\y, xType1\x, xType1\y, $214)
  EndProcedure

Macro WriteToolTip_AddLine()
  xLong4 = xLong4 + 2
  MoveToEx_(xLong1, 1, xLong4, 0)
  xhPen = CreatePen_(0, 0, SysColor23)
  If xhPen
    xhPenOld = SelectObject_(xLong1, xhPen)
    LineTo_(xLong1, CurShownToolTip_TotalWidthX, xLong4)
    SelectObject_(xLong1, xhPenOld)
    DeleteObject_(xhPen)
    EndIf
  xLong4 = xLong4 + 3
  EndMacro

Procedure WriteToolTip()
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xLong5
  Define.i xhPen
  Define.i xhPenOld
  Define.i xCount
  Define.s xChar1
  Define.i hFontOld

  xLong1 = GetDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip))
  If xLong1
    hFontOld = SelectObject_(xLong1, hFontTTip)
    SetBkColor_(xLong1, SysColor24)
    SetTextColor_(xLong1, SysColor23)
    SetBkMode_(xLong1, 1)

    xLong4 = #TTSpaceTop
    
    xChar1 = xStaticIconsToolTip(CurShownToolTip, 0) + #TTSplitter
    Repeat
      xLong2 = FindString(xChar1, #TTSplitter)
      If xLong2 = 0
        Break
        EndIf
      If xCount = 1
        WriteToolTip_AddLine()
        EndIf
      xCount = xCount + 1
      TextOut_(xLong1, #TTSpaceLeft, xLong4, @xChar1, xLong2 - 1)
      xLong4 = xLong4 + CurShownToolTip_SpHeight
      xChar1 = Mid(xChar1, xLong2 + 1)
      ForEver

    If Len(xStaticIconsToolTip(CurShownToolTip, 1))
      ;WriteToolTip_AddLine()
      xLong4 = xLong4 + 4
      xChar1 = LoadResString(1100)
      TextOut_(xLong1, #TTSpaceLeft, xLong4, @xChar1, Len(xChar1))
      
      xChar1 = xStaticIconsToolTip(CurShownToolTip, 1) + #TTSplitter ;2
      If FindString(xChar1, #TAB$) = 0
        xChar1 = #TAB$ + xChar1
        EndIf
      Repeat
        xLong2 = FindString(xChar1, #TTSplitterTab)
        xLong3 = FindString(xChar1, #TTSplitter)
        If xLong2 = 0 Or xLong3 = 0 Or xLong2 > xLong3
          Break
          EndIf
        ;If xLong2 = 0
        ;  xLong3 = xLong2
        ;  xLong2 = Len(xChar1)
        ;  EndIf
;Debug "TO1: 1, " + Str(xLong2 - 1) + " / " + Str(Len(xChar1))
        
        xLong5 = GetTextOutWidth(xLong1, Left(xChar1, xLong2 - 1))
        ;CurShownToolTip_SpKey
        ;TextOut_(xLong1, CurShownToolTip_SpKeyPre, xLong4, @xChar1, xLong2 - 1)
        TextOut_(xLong1, CurShownToolTip_SpKey - xLong5, xLong4, @xChar1, xLong2 - 1)
;Debug "TO2: " + Str(xLong2 + 1) + "/" + Str(Len(xChar1))
        CompilerIf #PB_Compiler_Unicode
          TextOut_(xLong1, CurShownToolTip_SpKey, xLong4, @xChar1 + (xLong2 << 1), xLong3 - xLong2 - 1)
          CompilerElse
          TextOut_(xLong1, CurShownToolTip_SpKey, xLong4, @xChar1 + xLong2, xLong3 - xLong2 - 1)
          CompilerEndIf
        xLong4 = xLong4 + CurShownToolTip_SpHeight
        xChar1 = Mid(xChar1, xLong3 + 1)
        ForEver
      EndIf
    SelectObject_(xLong1, hFontOld)
    ReleaseDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip), xLong1)
    EndIf
  EndProcedure

Procedure SetToolTip(Index.i, xChar1.s, xChar2.s)
  Define.RECT xType1

  If Not (xStaticIconsToolTip(Index, 0) = xChar1 And xStaticIconsToolTip(Index, 1) = xChar2)
    xStaticIconsToolTip(Index, 0) = xChar1
    xStaticIconsToolTip(Index, 1) = xChar2

    If ToolTipInitTime = -1 And Index = CurShownToolTip
      CalcToolTip()
      ;MainForm_EraseBackgroundTT()
      Index = GetDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip))
      If Index
        GetClientRect_(xStaticIconsHWnd(#xStaticIcons_ToolTip), @xType1)
        FillRect_(Index, @xType1, 25)
        ReleaseDC_(xStaticIconsHWnd(#xStaticIcons_ToolTip), Index)
        EndIf
      SendMessage_(xStaticIconsHWnd(#xStaticIcons_ToolTip), $F, 0, 0)
      EndIf
    EndIf
  EndProcedure

Procedure.i MainForm_MeasureAlignVolFaderA(xVolPos.i)
  ;Debug Hex(xVolume) + " -> " + Str(SignedLowerWord(xVolume))

  xVolPos - (xVolMTbWidth >> 1)
  If xVolPos < 0
    xVolPos = 0
    ElseIf xVolPos > xVolTotWidth - xVolMTbWidth - 1
    xVolPos = xVolTotWidth - xVolMTbWidth - 1
    EndIf
  ProcedureReturn Int((xVolPos * 255) / (xVolTotWidth - xVolMTbWidth - 1))
  EndProcedure

Procedure MainForm_DrawVolFaderA(xVolume.i)
  Define.i FaderPos
  Define.i xBmp
  Define.i xBmpOld
  Define.i xhPen
  Define.i xhPen2
  Define.i xhPenOld
  Define.RECT xType1
  Define.i xScWidth

  xBmp = CreateCompatibleBitmapX(xVolTotWidth, 16 * DPIScaleY)
  If xBmp
    xBmpOld = SelectObject_(xSharedDC, xBmp)
    xType1\Right = xVolTotWidth
    xType1\Bottom = 16 * DPIScaleY
    FillRect_(xSharedDC, @xType1, #FillSysColorFace)
    ;FaderPos = MulDiv_(32, xVolume, 255)
    FaderPos = MulDiv_(xVolTotWidth - xVolMTbWidth, xVolume, 255)
    MoveToEx_(xSharedDC, 0, 12 * DPIScaleY - 1, 0)
    xhPen = CreatePen_(0, 0, FormatIconBackSunkenD)
    If xhPen
      xhPenOld = SelectObject_(xSharedDC, xhPen)
      ;LineTo_(xSharedDC, 38, 3)
      LineTo_(xSharedDC, xVolTotWidth - 2, 3 * DPIScaleY)
      ;SetPixel_(xSharedDC, 38, 3, FormatIconBackSunkenD)
      SetPixel_(xSharedDC, xVolTotWidth - 2, 3 * DPIScaleY, FormatIconBackSunkenD)
      MoveToEx_(xSharedDC, 0, 12 * DPIScaleY, 0)
      xhPen2 = CreatePen_(0, 0, FormatIconBackSunkenW)
      If xhPen2
        SelectObject_(xSharedDC, xhPen2)
        LineTo_(xSharedDC, xVolTotWidth, 12 * DPIScaleY)
        MoveToEx_(xSharedDC, xVolTotWidth - 1, 3 * DPIScaleY, 0)
        LineTo_(xSharedDC, xVolTotWidth - 1, 12 * DPIScaleY)
        SelectObject_(xSharedDC, xhPen)
        DeleteObject_(xhPen2)
        EndIf
      xType1\left = FaderPos
      xType1\Right = xType1\left + xVolMTbWidth
      FillRect_(xSharedDC, @xType1, #FillSysColorSunkenW)
      xType1\left + 1
      xType1\Top = 1
      FillRect_(xSharedDC, @xType1, #FillSysColorSunkenD)
      SelectObject_(xSharedDC, xhPenOld)
      DeleteObject_(xhPen)
      EndIf
    xType1\Right - 1
    xType1\Bottom - 1;= 15 * DPIScaleY
    FillRect_(xSharedDC, xType1, #FillSysColorFace)
    SelectObject_(xSharedDC, xBmpOld)
    EndIf
  If xBmp
    SendMessage_(xStaticIconsHWnd(#xStaticIcons_Volume), $172, 0, xBmp)
    If xStaticIconsBMP(#xStaticIcons_Volume)
      DeleteObject_(xStaticIconsBMP(#xStaticIcons_Volume))
      EndIf
    xStaticIconsBMP(#xStaticIcons_Volume) = xBmp
    EndIf
  EndProcedure

Procedure MainForm_DrawRawBMP_CalaymStatic(xIsMp3Icon.i, *xData, xDataLen.i, IconMod.i)
  ;Define.BITMAPINFOHEADER xType1
  Define *xType1.BITMAPINFOHEADER
  Define.i hBmp
  Define.i hBmpOld
  Define *Mem2
  Define.i xLen2
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i PicDC
  Define.RECT xType2

  If *xData
    If xIsMp3Icon = -1
      xType2\Right = 16
      xType2\Bottom = 16
      Else
      xType2\Right = 20 * DPISCaleX
      xType2\Bottom = 16 * DPISCaleY
      EndIf
    hBmp = CreateCompatibleBitmapX(xType2\Right, xType2\Bottom)
    If hBmp
      hBmpOld = SelectObject_(xSharedDC, hBmp)
      If hBmpOld
        If (IconMod & $10000000)
          FillRect_(xSharedDC, @xType2, 17)
          xType2\left = 1
          xType2\Top = 1
          xType2\Right = xType2\Right - 1
          xType2\Bottom = xType2\Bottom - 1
          xLong1 = 21 ;FormatIconBackSunken
          ElseIf xIsMp3Icon = -1
          xLong1 = 6 ;FormatIconBack
          Else
          xLong1 = 16 ;FormatIconBack
          EndIf
        FillRect_(xSharedDC, @xType2, xLong1)
        xLong1 = GetSysColor_(xLong1 - 1)
        
        If xDataLen > 40
          ;RtlMoveMemory_(@xType1, *xData, 40)
          *xType1 = *xData
          ;40+4*2^1
          Select *xType1\biBitCount
            Case 8: *Mem2 = *xData + 1064: xDataLen - 1064 ; 40 + 4*256 indexes
            Case 4: *Mem2 = *xData +  104: xDataLen -  104 ; 40 + 4*16 indexes
            Case 1: *Mem2 = *xData +   48: xDataLen -   48 ; 40 + 4*x indexes
            EndSelect
          If xDataLen > 0
            xLong2 = *xData + 40 + (2 << (*xType1\biBitCount+1) - 4)
            PokeL(xLong2, xLong1)
            PokeL(xLong2 - 4, FormatIconFore)
            If Not *xType1\biBitCount = 1
              ;PokeL(xLong2 - 8, IconMod & $FFFFFF)
              EndIf
            xLong1 = CreateCompatibleBitmapX(*xType1\biWidth, *xType1\biHeight)
            If xLong1
              PicDC = CreateCompatibleDC_(0)
              If PicDC
                If SetDIBits_(PicDC, xLong1, 0, *xType1\biHeight, *Mem2, *xData, 0)
                  xLong2 = SelectObject_(PicDC, xLong1)
                  If xLong2
;Debug "### Offset: " + Str((IconMod >> 20) & $F0)
                    If xIsMp3Icon = -1
                      BitBlt_(xSharedDC, 0, 0, 16, 16, PicDC, 0, 0, #SRCCOPY)
                      Else
                      BitBlt_(xSharedDC, 10 * DPISCaleX - 8, 8 * DPISCaleY - 7, 16, 14, PicDC, 0, 0, #SRCCOPY)
                      EndIf
                    SelectObject_(PicDC, xLong2)
                    EndIf
                  EndIf
                DeleteDC_(PicDC)
                EndIf
              DeleteObject_(xLong1)
              EndIf
            EndIf
          EndIf
        SelectObject_(xSharedDC, hBmpOld)
        EndIf
      
      If xIsMp3Icon = -1
        If Not MP3FormatBitmap = 0
          DeleteObject_(MP3FormatBitmap)
          EndIf
        MP3FormatBitmap = hBmp
        Else
        SendMessage_(xStaticIconsHWnd(xIsMp3Icon), $172, 0, hBmp)
        If xStaticIconsBMP(xIsMp3Icon)
          DeleteObject_(xStaticIconsBMP(xIsMp3Icon))
          EndIf
        xStaticIconsBMP(xIsMp3Icon) = hBmp
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure MainForm_DrawRawEMF_CalaymStatic_CFx(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, lpData.i)
  ;Define.i xLong1
  Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
  Define.i *EMRL_CBI.EMRCREATEBRUSHINDIRECT
  Define.i xEMRL_ECP.EMREXTCREATEPEN
  Define.i *EMRL_ECP.EMREXTCREATEPEN

  If *lpEMFR
    ;Debug "EMFR: " + Str(*lpEMFR\iType)
    Select *lpEMFR\iType
      Case #EMR_CREATEBRUSHINDIRECT
        *EMRL_CBI = *lpEMFR
        If *EMRL_CBI\lb\lbColor = $ff00ff
          RtlMoveMemory_(@xEMRL_CBI, *lpEMFR, SizeOf(EMRCREATEBRUSHINDIRECT))
          xEMRL_CBI\lb\lbColor = FormatIconFore
          PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_CBI, nObj)
          Else
          PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
          EndIf
      Case #EMR_EXTCREATEPEN
        *EMRL_ECP = *lpEMFR
        If *EMRL_ECP\elp\elpColor = $ff00ff
          RtlMoveMemory_(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
          xEMRL_ECP\elp\elpColor = FormatIconFore
          PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
          Else
          PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
          EndIf
      Default
        PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
      EndSelect
    EndIf
    ;Select GetObjectType_(PeekI(*lpHTable))
      ;Case #OBJ_BRUSH
      ;Case #OBJ_FONT
      ;Case #OBJ_PAL
      ;Case #OBJ_PEN
      ;Case #OBJ_EXTPEN
      ;Case #OBJ_REGION
      ;Case #OBJ_DC
      ;Case #OBJ_MEMDC
      ;Case #OBJ_METAFILE
      ;Case #OBJ_METADC
      ;Case #OBJ_ENHMETAFILE
      ;Case #OBJ_ENHMETADC
      ;Default
      ;  Debug "OT: " + Str(PeekI(*lpHTable))
      ;EndSelect

  ProcedureReturn #True
  EndProcedure

Procedure MainForm_DrawRawEMF_CalaymStatic(xIsMp3Icon.i, *xData, xDataLen.i, IconMod.i)
  ;Define.BITMAPINFOHEADER xType1
  Define *xType1.BITMAPINFOHEADER
  Define.i hBmp
  Define.i hBmpOld
  Define.i xLong1
  Define.RECT xType2
  Define.i hMeta

  If xIsMp3Icon = -1
    xType2\Right = 16 * DPIScaleX
    Else
    xType2\Right = 20 * DPIScaleX
    EndIf
  xType2\Bottom = 16 * DPIScaleY

 
  If *xData
    hBmp = CreateCompatibleBitmapX(xType2\Right, 16 * DPIScaleY)
    If hBmp
      hBmpOld = SelectObject_(xSharedDC, hBmp)
      If hBmpOld
        If (IconMod & $10000000)
          FillRect_(xSharedDC, @xType2, 17)
          xType2\left = 1
          xType2\Top = 1
          xType2\Right = xType2\Right - 1
          xType2\Bottom = xType2\Bottom - 1
          xLong1 = 21 ;FormatIconBackSunken
          ElseIf xIsMp3Icon = -1
          xLong1 = 6 ;FormatIconBack
          Else
          xLong1 = 16 ;FormatIconBack
          EndIf
        FillRect_(xSharedDC, @xType2, xLong1)
        hMeta = SetEnhMetaFileBits_(xDataLen, *xData)
        If hMeta
          CompilerIf #SaveEMFScaling 
            If xIsMp3Icon = -1
              xLong1 = 8 * Int(DPIScaleX)
              xType2\left = 8 * DPIScaleX - xLong1
              xType2\right = xType2\left + xLong1 << 1
              xLong1 = 8 * Int(DPIScaleY)
              xType2\top = 8 * DPIScaleY - xLong1
              xType2\bottom = xType2\top + xLong1 << 1
              Else
              xLong1 = 8 * Int(DPIScaleX)
              xType2\left = 10 * DPIScaleX - xLong1
              xType2\right = xType2\left + xLong1 << 1
              xLong1 = 7 * Int(DPIScaleY)
              xType2\top = 8 * DPIScaleY - xLong1
              xType2\bottom = xType2\top + xLong1 << 1
              EndIf
            CompilerElse
            If xIsMp3Icon = -1
              xType2\right = 16 * DPIScaleX
              xType2\bottom = 16 * DPIScaleY
              Else
              xType2\left = 2
              xType2\top = 1
              xType2\right = 20 * DPIScaleX - 4
              xType2\bottom = 16 * DPIScaleY - 1
              EndIf
            CompilerEndIf
          EnumEnhMetaFile_(xSharedDC, hMeta, @MainForm_DrawRawEMF_CalaymStatic_CFx(), xLong1, @xType2)
          ;PlayEnhMetaFile_(xSharedDC, hMeta, @xType2)
          DeleteEnhMetaFile_(hMeta)
          EndIf
        SelectObject_(xSharedDC, hBmpOld)
        EndIf
      
      If xIsMp3Icon = -1
        If Not MP3FormatBitmap = 0
          DeleteObject_(MP3FormatBitmap)
          EndIf
        MP3FormatBitmap = hBmp
        Else
        SendMessage_(xStaticIconsHWnd(xIsMp3Icon), $172, 0, hBmp)
        If xStaticIconsBMP(xIsMp3Icon)
          DeleteObject_(xStaticIconsBMP(xIsMp3Icon))
          EndIf
        xStaticIconsBMP(xIsMp3Icon) = hBmp
        EndIf
      EndIf
    EndIf
  EndProcedure

Procedure MainForm_EraseBackground(hWnd.i)
  Define.i hDC
  Define.RECT xType1
  
  If GetClientRect_(hWnd, @xType1)
    hDC = GetDC_(hWnd)
    If hDC
      FillRect_(hDC, @xType1, #FillSysColorBack)
      ReleaseDC_(hWnd, hDC)
      EndIf
    EndIf
  EndProcedure

Procedure.i GetQualityStreamRGB(*xType1.ctSSLayerSongInfoBase)
  Define.i xResult
  Define.f xSingle1
  
  If *xType1\Format_VBR
    xSingle1 = 0.15
    EndIf

  xSingle1 = (0.5 + *xType1\Format_Frequency / 22050 * 0.25) * (Sqr(*xType1\Format_Channels) - 0.4) * *xType1\Format_BitRate / 224000 * (1 + xSingle1) * *xType1\Format_QualityMulti
  
  If xSingle1 >= 1
    xResult = $100A000
    ElseIf xSingle1 >= 0.75
    xResult = (1 - xSingle1) * $2800000
    xResult = (xResult & $FF0000) + $100A000
    ElseIf xSingle1 >= 0.5
    xResult = (1 - xSingle1) * $2800000
    xResult = ((xResult - $14000) & $FF00) + $1A00000
    ElseIf xSingle1 >= 0.25
    xResult = $1A00140 - xSingle1 * $280
    ElseIf xSingle1 > 0
    xResult = xSingle1 * $2800000
    xResult = (xResult & $FF0000) + $10000A0
    Else
    xResult = $10000A0
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 315
; FirstLine = 276
; Folding = ---
; EnableUnicode
; EnableXP