EnableExplicit

XIncludeFile #IncludePath + "BinaryBuffer_Base.pb"

Procedure.i BinaryBuffer_ReadMemEx(*hBinWrBuffer.BinaryBufferStruct, *Buffer, xLen)
  Define.i xResult

  If *hBinWrBuffer
    With *hBinWrBuffer
      If \hMem
        If \RPos + xLen > \WPos
          LocalFree_(\hMem)
          \hMem = 0
          Else
          If *Buffer
            RtlMoveMemory_(*Buffer, \RPos, xLen)
            EndIf
          xResult = \RPos
          \RPos + xLen
          EndIf
        EndIf
      EndWith
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Macro BinaryBuffer_ReadMemExI(hBinWrBuffer, VarI)
    BinaryBuffer_ReadMemEx(hBinWrBuffer, @VarI, 8)
    EndMacro
  CompilerElse
  Macro BinaryBuffer_ReadMemExI(hBinWrBuffer, VarI)
    BinaryBuffer_ReadMemEx(hBinWrBuffer, @VarI, 4)
    EndMacro
  CompilerEndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 14
; Folding = -
; EnableUnicode
; EnableXP