EnableExplicit

XIncludeFile #IncludePath + "BinaryBuffer_Base.pb"

Procedure.i BinaryBuffer_WriteMemEx(*hBinWrBuffer.BinaryBufferStruct, *Mem, xSize.i)
  Define.i xResult
  Define *Mem2
  Define.i xSize1
  Define.i xSize2
  Define.i xSize3

  If *hBinWrBuffer
    With *hBinWrBuffer
      If \hMem
        If xSize > \Left
          xSize1 = \RPos - \hMem
          xSize2 = \WPos - \hMem
          xSize3 = xSize2 + \Blck + xSize
          *Mem2 = LocalAlloc_(0, xSize3 + 4) ; 4 extrabytes for safety
          If *Mem2
            RtlMoveMemory_(*Mem2, \hMem, xSize2)
            LocalFree_(\hMem)
            ;\Blck
            \hMem = *Mem2
            \Left = xSize3 - xSize2
            \RPos = *Mem2 + xSize1
            \WPos = *Mem2 + xSize2
            EndIf
          EndIf
        If \hMem
          xResult = \WPos
          If *Mem
            RtlMoveMemory_(\WPos, *Mem, xSize)
            EndIf
          \Left - xSize
          \WPos + xSize
          EndIf
        EndIf
      EndWith
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Macro BinaryBuffer_WriteMemExI(hBinWrBuffer, VarI)
    BinaryBuffer_WriteMemEx(hBinWrBuffer, @VarI, 8)
    EndMacro
  CompilerElse
  Macro BinaryBuffer_WriteMemExI(hBinWrBuffer, VarI)
    BinaryBuffer_WriteMemEx(hBinWrBuffer, @VarI, 4)
    EndMacro
  CompilerEndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP