﻿EnableExplicit

XIncludeFile #IncludePath + "LoadResData.pb"

Procedure.i LoadResData_MultiOS(ResID.i, *ResType, *ptrSize)
  Define.i xResult
  Define.i xLong1

  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindowsVista
      xResult = LoadResData(ResID + 1, *ResType, *ptrSize)
      EndIf
    If Not xResult
      xResult = LoadResData(ResID, *ResType, *ptrSize)
      EndIf
    CompilerElseIf #PB_Compiler_Unicode
    If IsHighColor
      If IsMinWindowsVista
        xLong1 = 5
        ElseIf IsMinWindowsXP
        xLong1 = 4
        ElseIf IsMinWindows2000
        xLong1 = 3
        Else
        xLong1 = 2
        EndIf
      While xLong1 > 1 And Not xResult
        xResult = LoadResData(ResID + xLong1, *ResType, *ptrSize)
        xLong1 - 1
        Wend
      EndIf
    If Not xResult
      If IsMinWindows2000
        xResult = LoadResData(ResID + 1, *ResType, *ptrSize)
        EndIf
      If Not xResult
        xResult = LoadResData(ResID, *ResType, *ptrSize)
        EndIf
      EndIf
    CompilerElse
    If IsHighColor
      If IsMinWindowsME
        xLong1 = 4
        ElseIf IsMinWindows98
        xLong1 = 3
        Else
        xLong1 = 2
        EndIf
      While xLong1 > 1 And Not xResult
        xResult = LoadResData(ResID + xLong1, *ResType, *ptrSize)
        xLong1 - 1
        Wend
      EndIf
    If Not xResult
      If IsMinWindowsME
        xResult = LoadResData(ResID + 1, *ResType, *ptrSize)
        EndIf
      If Not xResult
        xResult = LoadResData(ResID, *ResType, *ptrSize)
        EndIf
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP