﻿EnableASM

Procedure.i LoadResEx_Image_MultiOS(ResID.i, ResType.i, DesiredSize.i = 32)
  Define.i xResult
  Define.i xFlags
  Define.i xLong1
  
  If ResType = 0
    xFlags = $2040
    DesiredSize = 0
    EndIf

  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindowsVista
      xResult = LoadImage_(hInstance, ResID + 1, ResType, DesiredSize, DesiredSize, xFlags)
;Debug "Vista+Image: " + Str(xResult)
      EndIf
    If Not xResult
;Debug "Image: " + Str(xResult)
      xResult = LoadImage_(hInstance, ResID, ResType, DesiredSize, DesiredSize, xFlags)
      EndIf
    CompilerElseIf #PB_Compiler_Unicode
    If IsHighColor
      If IsMinWindowsVista
        xLong1 = 5
        ElseIf IsMinWindowsXP
        xLong1 = 4
        ElseIf IsMinWindows2000
        xLong1 = 3
        Else
        xLong1 = 2
        EndIf
      While xLong1 > 1 And Not xResult
        xResult = LoadImage_(hInstance, ResID + xLong1, ResType, DesiredSize, DesiredSize, xFlags)
        xLong1 - 1
        Wend
      EndIf
    If Not xResult
      If IsMinWindows2000
        xResult = LoadImage_(hInstance, ResID + 1, ResType, DesiredSize, DesiredSize, xFlags)
        EndIf
      If Not xResult
        xResult = LoadImage_(hInstance, ResID, ResType, DesiredSize, DesiredSize, xFlags)
        EndIf
      EndIf
    CompilerElse
    If IsHighColor
      If IsMinWindowsME
        xLong1 = 4
        ElseIf IsMinWindows98
        xLong1 = 3
        Else
        xLong1 = 2
        EndIf
      While xLong1 > 1 And Not xResult
        xResult = LoadImage_(hInstance, ResID + xLong1, ResType, DesiredSize, DesiredSize, xFlags)
        xLong1 - 1
        Wend
      EndIf
    If Not xResult
      If IsMinWindowsME
        xResult = LoadImage_(hInstance, ResID + 1, ResType, DesiredSize, DesiredSize, xFlags)
        EndIf
      If Not xResult
        xResult = LoadImage_(hInstance, ResID, ResType, DesiredSize, DesiredSize, xFlags)
        EndIf
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 55
; FirstLine = 18
; Folding = -
; EnableUnicode
; EnableXP