EnableExplicit

XIncludeFile #IncludePath + "AquirePrivilege.pb"

Enumeration ShutDownWindowsEx_Mode
  #SDWE_Shutdown = 1
  #SDWE_Hibernate = 2
  #SDWE_Standby = 3
  #SDWE_MonitorsOff = 4
  EndEnumeration

;boolean
Procedure.i ShutdownWindowsEx(Mode.i)
  Define.i xResult
  Define.i xLong1

  AquirePrivilege("SeShutdownPrivilege")
  Select Mode
    Case #SDWE_Shutdown
      If ExitWindowsEx_(9, 0)
        xResult = #True
        EndIf
    Case #SDWE_Hibernate, #SDWE_Standby
      If Mode = #SDWE_Hibernate
        xLong1 = 1
        EndIf
      Mode = GetModuleHandle_(@"kernel32.dll")
      If Mode
        Mode = GetProcAddress(Mode, "SetSystemPowerState")
        If Mode
          If CallFunctionFast(Mode, xLong1, 0)
            xResult = #True
            EndIf
          EndIf
        EndIf
    Case #SDWE_MonitorsOff
      If SendMessage_(-1, $112, $F170, 1)
        xResult = #True
        EndIf
    EndSelect
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 26
; FirstLine = 18
; Folding = -
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory