﻿EnableExplicit

XIncludeFile #IncludePath + "TxtFileReader_Core.pb"

Procedure.i TxtFileReader_LBParser(*ptrStringW, *ptrLenOut)
  Define.i xResult
  Define.i xLong1
  Define *Mem

  *Mem = *ptrStringW
  Repeat
    xLong1 = PeekW(*Mem)
    If Not xLong1
      Break
      EndIf
    If xLong1 = 13
      If PeekW(*Mem + 2) = 10
        xLong1 = 4
        Else
        xLong1 = 2
        EndIf
      PokeI(*ptrLenOut, xLong1)
      xResult = *Mem
      Break
      EndIf
    If xLong1 = 10
      PokeI(*ptrLenOut, 2)
      xResult = *Mem
      Break
      EndIf
    *Mem = *Mem + 2
    ForEver
  ProcedureReturn xResult
  EndProcedure

;boolean -> ptrstr (ptrtemp?)
Procedure.i TxtFileReader_NextLine(*hTxtFileIn.TxtFileReadStruct)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2

  If *hTxtFileIn
    If *hTxtFileIn\hMem And Not *hTxtFileIn\hMemPos = *hTxtFileIn\hMemEnd
      *hTxtFileIn\LastPos = *hTxtFileIn\hMemPos
      xLong1 = TxtFileReader_LBParser(*hTxtFileIn\hMemPos, @xLong2)
      If xLong1
        *hTxtFileIn\LastEnd = xLong1
        *hTxtFileIn\hMemPos = xLong1 + xLong2
        xResult = #True
        Else
        *hTxtFileIn\LastEnd = *hTxtFileIn\LastPos
        LocalFree_(*hTxtFileIn\hMem)
        *hTxtFileIn\hMem = 0
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s TxtFileReader_GetLineString(*hTxtFileIn.TxtFileReadStruct)
  Define.s xResult
  If *hTxtFileIn
    If *hTxtFileIn\LastPos And *hTxtFileIn\LastEnd
      If Not *hTxtFileIn\LastPos = *hTxtFileIn\LastEnd
        xResult = PeekS(*hTxtFileIn\LastPos, (*hTxtFileIn\LastEnd - *hTxtFileIn\LastPos) >> 1, #PB_Unicode)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 59
; FirstLine = 38
; Folding = -
; EnableUnicode
; EnableXP