﻿EnableExplicit

Procedure.s URLEncode(xURL.s, ExcludeChars.s = "")
  Define.s xResult
  Define.i xLong1
  Define *Mem1
  Define *Mem2
  Define *Mem3
  Define *Mem4
  
  xLong1 = StringByteLength(xURL, #PB_UTF8)
  If xLong1
    *Mem1 = LocalAlloc_(0, xLong1 + 2)
    If *Mem1
      xLong1 = PokeS(*Mem1, xURL, -1, #PB_UTF8)
      If xLong1
        *Mem2 = LocalAlloc_(0, xLong1 << 4 + 1)
        If *Mem2
          *Mem3 = *Mem1
          *Mem4 = *Mem2
          Repeat
            xLong1 = PeekW(*Mem3) & $ff
            If Not xLong1
              Break
              EndIf
            If FindString(ExcludeChars, Chr(xLong1))
              PokeW(*Mem4, xLong1)
              *Mem4 + 1
              Else
              Select xLong1
                Case 45, 46, 48 To 57, 65 To 90, 95, 97 To 122 ;, 126
                  PokeB(*Mem4, xLong1)
                  *Mem4 + 1
                Case 32
                  PokeB(*Mem4, 43) ;"+"
                  *Mem4 + 1
                Default
                  PokeB(*Mem4+0, 37) ; "%"
                  If xLong1 > $9F
                    PokeB(*Mem4+1, (xLong1 >> 4) + 55)
                    Else
                    PokeB(*Mem4+1, (xLong1 >> 4) + 48)
                    EndIf
                  xLong1 & $F
                  If xLong1 > 9
                    PokeB(*Mem4+2, xLong1 + 55)
                    Else
                    PokeB(*Mem4+2, xLong1 + 48)
                    EndIf
                  *Mem4 + 3
                EndSelect
              EndIf
            *Mem3 + 1
            ForEver
          PokeB(*Mem4, 0)
          xResult = PeekS(*Mem2, -1, #PB_Ascii)
          LocalFree_(*Mem2)
          EndIf
        EndIf
      LocalFree_(*Mem1)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 64
; FirstLine = 39
; Folding = -
; EnableUnicode
; EnableXP