EnableExplicit

#DPIScaling_Init = #True

Procedure DPIScaling_Init()
  Global ScaleDPIX.i
  Global ScaleDPIY.i
  Define.i xLong1

  ScaleDPIX = 96
  ScaleDPIY = 96
  xLong1 = GetModuleHandle_(@"user32.dll")
  If xLong1
    xLong1 = GetProcAddress(xLong1, "SetProcessDPIAware")
    If xLong1
      If CallFunctionFast(xLong1)
        xLong1 = GetDC_(0)
        If xLong1
          ScaleDPIX = GetDeviceCaps_(xLong1, #LOGPIXELSX)
          ScaleDPIY = GetDeviceCaps_(xLong1, #LOGPIXELSY)
          ReleaseDC_(0, xLong1)
          EndIf
        EndIf
      EndIf
    EndIf
  EndProcedure

Macro DPIScaleX(Value)
  Value * ScaleDPIX / 96
  EndMacro

Macro DPIScaleY(Value)
  Value * ScaleDPIY / 96
  EndMacro

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 11
; FirstLine = 8
; Folding = -
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory