﻿EnableExplicit

CompilerIf Not #PB_Compiler_Unicode
  #WaitableTimer_Init = #True

  Procedure WaitableTimer_Init()
    Global *CreateWaitableTimer
    
    *CreateWaitableTimer = GetModuleHandle_(@"kernel32.dll")
    If *CreateWaitableTimer
      *CreateWaitableTimer = GetProcAddress(*CreateWaitableTimer, "CreateWaitableTimer")
      EndIf
    EndProcedure
  CompilerEndIf

Procedure DoEventsEx_Sleep(IntervalMS.i)
  Define.FILETIME xType1
  Define.i xLong1
  Define.i xLong2

CompilerIf #PB_Compiler_Unicode
     xLong1 = CreateWaitableTimer_(0, #True, 0)
CompilerElse
  If *CreateWaitableTimer
    xLong1 = CallFunctionFast(*CreateWaitableTimer, 0, #True, 0)
CompilerEndIf
    If xLong1
      xType1\dwLowDateTime = -1
      xType1\dwHighDateTime = -1
      SetWaitableTimer_(xLong1, xType1, 0, 0, 0, 0)
      xType1\dwLowDateTime = IntervalMS * -10000
      SetWaitableTimer_(xLong1, xType1, 0, 0, 0, #False)
      While MsgWaitForMultipleObjects_(1, @xLong1, #False, -1, 255)
        DoEvents()
        Wend
      DoEvents()
      CloseHandle_(xLong1)
      EndIf
CompilerIf Not #PB_Compiler_Unicode
    EndIf
CompilerEndIf
  If Not xLong1
    xLong1 = GetTickCount_() & $3FFFFFFF
    Repeat
      DoEvents()
      Sleep_(#DoeventsEx_SleepValueLow)
      DoEvents()
      xLong2 = GetTickCount_() & $3FFFFFFF
      If xLong2 < xLong1
        If xLong2 + $40000000 - xLong1 > IntervalMS
          Break
          EndIf
        ElseIf (xLong2 - xLong1) > IntervalMS
        Break
        EndIf
      ForEver
    DoEvents()
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.20 LTS (Windows - x64)
; CursorPosition = 32
; FirstLine = 13
; Folding = -
; EnableUnicode
; EnableXP
; AddResource = ..\Calaym64\res\lng\en.rc