EnableExplicit

#BetterMenuPosition = #False

Structure CMINVOKECOMMANDINFOEX
  cbSize.l
  fMask.l
  hwnd.i
  lpVerb.i
  lpParameters.i
  lpDirectory.i
  nShow.l
  dwHotKey.l
  hIcon.i
  lpTitle.i
  lpVerbW.i
  lpParametersW.i
  lpDirectoryW.i
  lpTitleW.i
  ptInvoke.POINT
  EndStructure

XIncludeFile #IncludePath + "OLEInterface_Release.pb"
XIncludeFile #IncludePath + "OLEInterface_CallFunction1.pb"
XIncludeFile #IncludePath + "OLEInterface_CallFunction4.pb"
XIncludeFile #IncludePath + "OLEInterface_CallFunction5.pb"
XIncludeFile #IncludePath + "OLEInterface_CallFunction6.pb"
XIncludeFile #IncludePath + "GetAPIPopupMenu.pb"
XIncludeFile #IncludePath + "MakePopupMenu.pb"

DataSection
  IID_IShellFolder: ; {000214E6-0000-0000-C000-000000000046}
    Data.l $000214E6
    Data.w $0000, $0000
    Data.b $C0, $00, $00, $00, $00, $00, $00, $46

  IID_IContextMenu: ; {000214E4-0000-0000-C000-000000000046}
    Data.l $000214E4
    Data.w $0000, $0000
    Data.b $C0, $00, $00, $00, $00, $00, $00, $46
  EndDataSection

Procedure FolderContextMenuEx(hWnd.i, *DirW, *FilW)
  Define *Desktop
  Define *ParentIDL
  Define *ParentISF
  Define *FileIDL
  Define *ShellMenu
  Define.i xLong1
  Define.i hMenu
  Define.i hPopupMenu
  Define.CMINVOKECOMMANDINFOEX info

;Debug "Dir: " + PeekS(*DirW, -1, #PB_Unicode)
;Debug "Fil: " + PeekS(*FilW, -1, #PB_Unicode)
  If SHGetDesktopFolder_(@*Desktop) = #S_OK
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    If OLEInterface_CallFunction6(*Desktop, $18, hWnd, #Null, *DirW, #Null, @*ParentIDL, #Null) = #S_OK
      If OLEInterface_CallFunction4(*Desktop, $28, *ParentIDL, #Null, ?IID_IShellFolder, @*ParentISF) = #S_OK
        If OLEInterface_CallFunction6(*ParentISF, $18, hWnd, #Null, *FilW, #Null, @*FileIDL, #Null) = #S_OK
          If OLEInterface_CallFunction6(*ParentISF, $50, hWnd, 1, @*FileIDL, ?IID_IContextMenu, 0, @*ShellMenu) = #S_OK
CompilerElse
    If OLEInterface_CallFunction6(*Desktop, $C, hWnd, #Null, *DirW, #Null, @*ParentIDL, #Null) = #S_OK
      If OLEInterface_CallFunction4(*Desktop, $14, *ParentIDL, #Null, ?IID_IShellFolder, @*ParentISF) = #S_OK
        If OLEInterface_CallFunction6(*ParentISF, $C, hWnd, #Null, *FilW, #Null, @*FileIDL, #Null) = #S_OK
          If OLEInterface_CallFunction6(*ParentISF, $28, hWnd, 1, @*FileIDL, ?IID_IContextMenu, 0, @*ShellMenu) = #S_OK
CompilerEndIf
            hMenu = CreateMenu_()
            If hMenu
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
              If OLEInterface_CallFunction5(*ShellMenu, $18, hMenu, 0, 0, 9999, 16) >= 0
CompilerElse
              If OLEInterface_CallFunction5(*ShellMenu, $c, hMenu, 0, 0, 9999, 16) >= 0
CompilerEndIf
                hPopupMenu = MakePopupMenu(hMenu)
                If hPopupMenu
                  #TPM_NONOTIFY = $80
                  #TPM_RETURNCMD = $100
                  xLong1 = GetAPIPopupMenu(hWnd, hMenu, 0)
                  ;xLong1 = TrackPopupMenu_(hMenu, #TPM_NONOTIFY | #TPM_RETURNCMD, 0, 0, 0, hWnd, 0)
                  If xLong1
                    info\cbSize = SizeOf(CMINVOKECOMMANDINFOEX)
                    info\fMask  = 0
                    info\hwnd   = hWnd
                    info\lpVerb = xLong1
                    info\nShow  = 5 ;#SW_SHOWNORMAL
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                    OLEInterface_CallFunction1(*ShellMenu, $20, @info)
CompilerElse
                    OLEInterface_CallFunction1(*ShellMenu, $10, @info)
CompilerEndIf
                    EndIf
                  DestroyMenu_(hPopupMenu)
                  EndIf
                EndIf
              DestroyMenu_(hMenu)
              ;SetMenu_(hWndMain, hPopupMenu)
              ;DrawMenuBar_(hWndMain)
              EndIf
            OLEInterface_Release(*ShellMenu)
            EndIf    
          CoTaskMemFree_(*FileIDL)
          EndIf
        OLEInterface_Release(*ParentISF)
        EndIf 
      CoTaskMemFree_(*ParentIDL)
      EndIf
    OLEInterface_Release(*Desktop)
    EndIf
  EndProcedure
; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 78
; FirstLine = 76
; Folding = -
; EnableXP