EnableExplicit

XIncludeFile #IncludePath + "GetTickCountAPI.pb"

#HtmlHelp = #True

Procedure.i HtmlHelp_Init()
  Global *HtmlHelp
  Global HtmlHelp_LastCall.i
  EndProcedure

Procedure.i HtmlHelpEx(hWnd.i, *lpHelpFile, wCommand.i, *dwdata)
  Define.i xLong1
  Define.i xLong2

  xLong1 = LoadLibrary_(@"hhctrl.ocx")
  If xLong1
    xLong2 = GetProcAddressAW(xLong1, "HtmlHelp")
    If xLong2
      xLong2 = CallFunctionFast(xLong2, hWnd, *lpHelpFile, wCommand, *dwdata)
      EndIf
    EndIf
  ProcedureReturn xLong2
  EndProcedure

Procedure HtmlHelpClose()
  If HtmlHelp_LastCall
    HtmlHelp_LastCall = 1000 - GetElapsedTickTimeMS(HtmlHelp_LastCall)
    If HtmlHelp_LastCall > 0 And HtmlHelp_LastCall < 1000
      Sleep_(HtmlHelp_LastCall)
      EndIf
    HtmlHelp_LastCall = 0
    HtmlHelpEx(0, 0, $12, 0)
    EndIf
  EndProcedure

Procedure.i HtmlHelp(hWnd.i, lpHelpFile.s, wCommand.i, *dwdata)
  Define.i xResult
  Define.i xLong1
  
  If wCommand = $12
    HtmlHelpClose()
    Else
    CompilerIf #PB_Compiler_Unicode
      xLong1 = GetShortPathName_(@lpHelpFile, *ptrTemp, 257)
      If xLong1 And (xLong1 < 257)
        lpHelpFile = PeekS(*ptrTemp, xLong1)
        EndIf
      CompilerEndIf
    xResult = HtmlHelpEx(hWnd, @lpHelpFile, wCommand, *dwdata)
    If HtmlHelp_LastCall
      HtmlHelp_LastCall = GetTickTimeMS()
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 15
; FirstLine = 12
; Folding = -
; EnableUnicode
; EnableXP