﻿EnableExplicit

Structure STORAGE_HOTPLUG_INFO
  Size.l
  MediaRemovable.b
  MediaHotplug.b
  DeviceHotplug.b
  WriteCacheEnableOverride.b
  Extra.b ; size on call is 9, working so keeping!
  EndStructure

;boolean
Procedure.i IsRemoveableDrive(DriveLetterID.i)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 Or #PB_Compiler_Unicode
    Define.i xResult
    Define.i xLong1
    Define.s xChar1
    Define.STORAGE_HOTPLUG_INFO xType1

CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
    If IsMinWindows2000
CompilerEndIf
      xChar1 = "\\.\" + Chr(65 + DriveLetterID) + ":"
      DriveLetterID = CreateFile_(@xChar1, 0, 3, 0, 3, 0, 0)
      If Not DriveLetterID = -1
        If DeviceIoControl_(DriveLetterID, $2D0C14, 0, 0, @xType1, 9, @xLong1, 0)
          If xType1\MediaRemovable Or xType1\DeviceHotplug
            xResult = #True
            EndIf
          EndIf
        CloseHandle_(DriveLetterID)
        EndIf
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      EndIf
CompilerEndIf
    ProcedureReturn xResult
    CompilerElse
    ProcedureReturn 0
    CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 20
; FirstLine = 13
; Folding = -
; EnableUnicode
; EnableXP