EnableExplicit

CompilerIf #PB_Compiler_Unicode
  XIncludeFile #IncludePath + "LoadResData_MultiOS.pb"
  XIncludeFile #IncludePath + "IconFromEMF.pb"

CompilerIf Defined(Shell_NotifyIcon, #PB_Constant)
  Procedure LoadResEx_WindowIconEMF_MultiOS(hWnd, ResID, ResIDSmallFB, *ptrTrayToUpdate.NOTIFYICONDATA = 0)
CompilerElse
  Procedure LoadResEx_WindowIconEMF_MultiOS(hWnd, ResID, ResIDSmallFB)
CompilerEndIf
    Define.i lEMF
    Define *EMF
    Define.i hMeta
    Define.i hIcon
    Define.i xSuccess
    Define.i xLong1
    CompilerIf Defined(Shell_NotifyIcon, #PB_Constant)
      Define.i xLong2
      CompilerEndIf
  
    ;If Not (GetSystemMetrics_(#SM_CXSMICON) = 16 And GetSystemMetrics_(#SM_CYSMICON) = 16 And GetSystemMetrics_(#SM_CXICON) = 32 And GetSystemMetrics_(#SM_CYICON) = 32 And ResIDSmallFB)
      *EMF = LoadResData_MultiOS(ResID, @"emf", @lEMF)
      If *EMF
        hMeta = SetEnhMetaFileBits_(lEMF, *EMF)
        If hMeta
          hIcon = IconFromEMF(hMeta, GetSystemMetrics_(#SM_CXSMICON), GetSystemMetrics_(#SM_CYSMICON))
          If hIcon
            xSuccess = #True
            CompilerIf Defined(Shell_NotifyIcon, #PB_Constant)
              If *ptrTrayToUpdate
                xLong1 = CopyIcon_(hIcon)
                xLong2 = *ptrTrayToUpdate\hIcon
                *ptrTrayToUpdate\hIcon = xLong1
                Shell_NotifyIcon(1, *ptrTrayToUpdate)
                DestroyIcon_(xLong2)
                EndIf
              CompilerEndIf
  
            hIcon = SendMessage_(hWnd, $80, 0, hIcon)
            If hIcon
              DestroyIcon_(hIcon)
              EndIf
            EndIf
          hIcon = IconFromEMF(hMeta, GetSystemMetrics_(#SM_CXICON), GetSystemMetrics_(#SM_CYICON))
          If hIcon
            xSuccess = #True
            hIcon = SendMessage_(hWnd, $80, 1, hIcon)
            If hIcon
              DestroyIcon_(hIcon)
              EndIf
            EndIf
          DeleteEnhMetaFile_(hMeta)
          EndIf
        ;IconFromEMF
        EndIf
      ;EndIf
    If Not xSuccess
      If ResIDSmallFB
        CompilerIf Defined(Shell_NotifyIcon, #PB_Constant)
          LoadResEx_WindowIcon_MultiOS(hWnd, ResID, ResIDSmallFB, *ptrTrayToUpdate)
          CompilerElse
          LoadResEx_WindowIcon_MultiOS(hWnd, ResID, ResIDSmallFB)
          CompilerEndIf
        EndIf
      EndIf
CompilerIf Defined(Shell_NotifyIcon, #PB_Constant)
    EndProcedure
CompilerElse
    EndProcedure
CompilerEndIf
  CompilerElse
  Macro LoadResEx_WindowIconEMF_MultiOS(hWnd, ResID, ResIDSmall, ptrTray)
    LoadResEx_WindowIcon_MultiOS(hWnd, ResID, ResIDSmall, ptrTray)
    EndMacro
  CompilerEndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 21
; FirstLine = 15
; Folding = --
; EnableUnicode
; EnableXP