EnableExplicit

XIncludeFile #IncludePath + "RegEnumKey.pb"

Procedure SoundSchemes_ClearInt(SchemeNameEx.s, ApplicationName.s, DeleteEntireSheme.i)
  Define.i hKey1
  Define.i xCnt1
  Define.i hKey2
  Define.s xChar1
  Define.s xChar2

  xChar1 = "AppEvents\Schemes\Apps\" + ApplicationName
  If Not RegOpenKeyEx_($80000001, @xChar1, 0, 8, @hKey1)
    ApplicationName = ApplicationName + "\"
    Repeat
      xChar1 = RegEnumKey(hKey1, xCnt1)
      If Not Len(xChar1)
        Break
        EndIf
      xChar2 = "AppEvents\Schemes\Apps\" + ApplicationName + xChar1 + SchemeNameEx
      If Not RegOpenKeyEx_($80000001, @xChar2, 0, 2, @hKey2)
;Debug "DeleteValue() in : " + xChar2
        RegDeleteValue_(hKey2, "")
        RegCloseKey_(hKey2)
        EndIf
      If DeleteEntireSheme
        xChar2 = "AppEvents\Schemes\Apps\" + ApplicationName + xChar1 + SchemeNameEx
;Debug "DeleteKey : " + xChar2
        RegDeleteKey_($80000001, @xChar2)
        EndIf
      xCnt1 + 1
      ForEver
    If DeleteEntireSheme
      xChar2 = "AppEvents\Schemes\Names" + SchemeNameEx
;Debug "DeleteKeyPost : " + xChar2
      RegDeleteKey_($80000001, @xChar2)
      EndIf
    RegCloseKey_(hKey1)
    EndIf
  EndProcedure

Procedure SoundSchemes_ClearAll(SchemeName.s, DeleteEntireSheme.i)
  Define.i hKey
  Define.i xCnt1
  Define.s xChar1

  SchemeName = "\" + SchemeName
  If DeleteEntireSheme
    If LCase(SchemeName) = ".current"
      DeleteEntireSheme = #False
      EndIf
    EndIf

  If Not RegOpenKeyEx_($80000001, @"AppEvents\Schemes\Apps", 0, 8, @hKey)
    Repeat
      xChar1 = RegEnumKey(hKey, xCnt1)
      If Not Len(xChar1)
        Break
        EndIf
      SoundSchemes_ClearInt(SchemeName, xChar1, DeleteEntireSheme)
      xCnt1 + 1
      ForEver
    RegCloseKey_(hKey)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableUnicode
; EnableXP