EnableExplicit

Enumeration TBPF_ProgressState
  #TBPF_NoProgress = $0
  #TBPF_Indeterminate = $1
  #TBPF_Normal = $2
  #TBPF_Error = $4
  #TBPF_Paused = $8
  EndEnumeration

XIncludeFile #IncludePath + "OLEInterface_CallFunction2.pb"
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  XIncludeFile #IncludePath + "OLEInterface_CallFunction3.pb"
  CompilerElse
  XIncludeFile #IncludePath + "OLEInterface_CallFunction5.pb"
  CompilerEndIf
XIncludeFile #IncludePath + "OLEInterface_Release.pb"

DataSection
  CLSID_TaskbarList:
    ; 56FDF344-FD6D-11D0-958A-006097C9A090
    !DD $56FDF344
    !DW $FD6D, $11D0, $8A95
    !DB $00, $60, $97, $C9, $A0, $90
  ;IID_ITaskbarList:
  ;  ; {56FDF342-FD6D-11D0-958A-006097C9A090}
  ;  !DD $56FDF342
  ;  !DW $FD6D, $11D0, $8A95
  ;  !DB $00, $60, $97, $C9, $A0, $90
  IID_ITaskbarList3:
     !DD $EA1AFB91
     !DW $9E28, $4B86
     !DB $90, $E9, $9E, $9F, $8A, $5E, $EF, $AF
  EndDataSection

Procedure TaskBarProgress_Init(*VarPointer)
  If IsMinWindows7
    CoCreateInstance_(?CLSID_TaskbarList, 0, 5, ?IID_ITaskbarList3, *VarPointer)
    EndIf
  EndProcedure

Macro TaskBarProgress_Release(Var)
  OLEInterface_Release(Var)
  EndMacro

Macro TaskBarProgress_SetState(Var, hWnd, State)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    OLEInterface_CallFunction2(Var, $50, hWnd, State)
    CompilerElse
    OLEInterface_CallFunction2(Var, $28, hWnd, State)
    CompilerEndIf
  EndMacro

Macro TaskBarProgress_SetProgress(Var, hWnd, Progress, Total)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    OLEInterface_CallFunction3(Var, $48, hWnd, Progress, Total)
    CompilerElse
    OLEInterface_CallFunction5(Var, $24, hWnd, Progress, 0, Total, 0)
    CompilerEndIf
  EndMacro
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 30
; FirstLine = 15
; Folding = -
; Executable = CleanupEmptyDirs.exe
; CommandLine = "T:\GameMusicRipp\2011\Alien Breed 2 - Assault"
; CompileSourceDirectory