﻿EnableExplicit

XIncludeFile #IncludePath + "TxtFileWriter_Main.pb"
XIncludeFile #IncludePath + "TxtFileReader_FromFile.pb"

Procedure.i TxtFileWriter_AppendFileEx(Filename.s, DefaultEncoding.i, DefaultByteOrderMark.i)
  Define.i xLong1
  Define *xType1.TxtFileWriteStruct

  *xType1 = LocalAlloc_(0, SizeOf(TxtFileWriteStruct))
  If *xType1
    *xType1\hFile = TxtFileReader_OpenEx(Filename, @*xType1\Encoding, @xLong1, #True)
    If *xType1\hFile = -1
      LocalFree_(*xType1)
      *xType1 = 0
      If (GetFileAttributes_(Filename) & $ffffffff) = $ffffffff
        *xType1 = TxtFileWriter_CreateFileEx(Filename, DefaultEncoding, DefaultByteOrderMark)
        EndIf
      EndIf
    EndIf
  ProcedureReturn *xType1
  EndProcedure

CompilerIf #PB_Compiler_Unicode
  Macro TxtFileWriter_AppendFile(Filename)
    TxtFileWriter_AppendFileEx(Filename, #CP_WINUNICODE, #True)
    EndMacro
  CompilerElse
  Macro TxtFileWriter_AppendFile(Filename)
    TxtFileWriter_AppendFileEx(Filename, #CP_ACP, #False)
    EndMacro
  CompilerEndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 15
; Folding = -
; EnableUnicode
; EnableXP